<script>
//Init
$(function(){
	//Init le Datepicker jquery-UI
	$("#datepickerCalendar").datepicker({
		firstDay:1,
		showOtherMonths: true,
		selectOtherMonths: true,
		dateFormat:"yy-mm-dd",//utile pour le "onSelect"
		onSelect:function(curDate){
			var dateDate=new Date(curDate);
			redir("?ctrl=calendar&curTime="+Math.round(dateDate.valueOf()/1000));
		}
	});
	//Initialise la vue des agendas
	calendarInitVue();
	$(window).resize(function(){ calendarInitVue(); });
});

////	Calendar dimensions
function calendarInitVue()
{
	//Style des blocks d'événement
	$(".vCalEvtBlock").each(function(){ $(this).css("background",$(this).attr("data-catColor")); });
	//Synthese des agendas : Fixe la taille des cellule de jours
	if($("#syntheseTable").exist()){
		var syntheseDayWidth=Math.round(($("#syntheseLineHeader").width()-$("#syntheseLineHeader .vSyntheseLabel").width()) / $("#syntheseLineHeader .vSyntheseDay").length);
		$(".vSyntheseDay").css("width",syntheseDayWidth);
	}
	//Les agendas prennent toute la hauteur dispo sur la page (au minimum)
	$(".vCalendarBlock").css("height",availableContentHeight());
	$(".vCalendarVue").each(function(){
		var calObjId=$(this).attr("data-targetObjId");
		var calContentHeight=$("#blockCal"+calObjId).innerHeight() - $("#headerCal"+calObjId).outerHeight(true);
		$(this).css("height",calContentHeight+"px");
	});
	//Affichage de la vue week/month
	calendarDimensions();
}
</script>


<style>
/*Menus de gauche de la page*/
.vVisibleCals				{max-height:300px; overflow-y:auto;}
#adminDisplayAllCals		{float:right;}
.vVisibleCals>div			{padding:3px;}
.vVisibleCals .menuLaunch, .vVisibleCals [type='checkbox'], .vVisibleCals .formMainButton	{display:none;}
.vVisibleCals>div:hover .menuLaunch	{display:inline;}
.ui-datepicker				{width:97%; border:0px;}
#vMenuCategory a			{display:block; padding:5px 0px 5px 0px;}
#categoryColorAll			{border:solid #000 1px;}

/*Synthese des agendas*/
#syntheseTable				{display:table; width:100%;}
#syntheseLineHeader, .vSyntheseLine, .vSyntheseLineFooter	{display:table-row;}
.vSyntheseDayCurDay			{color:#c00;}
.vSyntheseLabel				{display:table-cell; width:160px; padding:2px; padding-left:5px; vertical-align:middle;}
.vSyntheseLine:hover .vSyntheseLabel	{color:#c00;}
.vSyntheseLineFooter .vSyntheseLabel	{font-style:italic;}
.vSyntheseDay				{display:table-cell; vertical-align:middle; text-align:center; height:22px;}
.vSyntheseDayEvts			{display:table; width:100%; height:100%;}
.vSyntheseDayEvt			{display:table-cell; border-left:transparent; font-size:5px;}
.vSyntheseDayEvts:hover		{opacity:0.5;}
.vSyntheseLineFooter .vSyntheseDayEvt {cursor:help;}
.vSyntheseDayEvtTooltip		{text-align:left;}
.vSyntheseDayEvtTooltip	ul	{margin:0px; margin-top:5px; padding-left:10px;}
.vSyntheseDayCal			{background:#ddd; border:dotted 1px #eee;}
.vSyntheseDayCal.vSyntheseDayCalWE	{background:#ccc;}

/*Agendas*/
.vCalendarBlock				{margin-top:25px; padding:0px; min-height:300px;}
.vCalendarBlock:first-child	{margin-top:0px;}
.vCalendarHeader			{display:table; width:100%;}
.vCalendarHeader>div		{display:table-cell; width:33%; padding:8px; vertical-align:middle;}
.vCalendarTitle				{text-transform:uppercase;}
.vCalendarTitle .menuLaunch	{margin-right:10px; height:18px;}
.vCalendarTitle .personPicture	{margin-right:10px; height:23px; width:23px; border-radius:50%;}
.vCalendarPeriod			{text-align:center;}
.vCalendarDisplayMode		{text-align:right;}
.vCalendarPrevNext			{margin-left:8px; margin-right:8px;}
#calMonthPeriodMenu			{width:250px;}
#calMonthPeriodMenu2 a		{display:inline-block; width:70px; padding:2px; text-align:left;}

/*Evenements*/
.vCalEvtBlock				{padding:3px; margin:0px; box-shadow:none;}
.vCalEvtBlock img[src*='menuSmall']	{margin-bottom:3px;}
.vCalEvtLabel				{height:inherit; overflow:hidden; cursor:pointer; font-weight:normal; font-size:90%; line-height:12px; color:#fff;}/*pas dépasser du block parent*/
.vCalEvtLabel img			{max-height:13px;}

/*RESPONSIVE*/
@media screen and (max-width:1024px){
	.vCalendarHeader, .vCalendarHeader>div	{white-space:nowrap!important; font-size:95%;}
	.vCalendarTitle		{text-transform:lowercase;}
	.vCalendarTitle>img	{margin-right:5px; height:14px;}
	.vCalendarPrevNext	{margin:2px;}
}

/* IMPRESSION */
@media print {
	@page {size:landscape;}
	.vSynthese, .vCalendarDisplayMode	{display:none;}/*affiche pas la synthese des agendas, ni les menus de chaque agendas*/
	.vCalendarPeriod			{text-align:right;}
	.vCalendarBlock				{page-break-after:always; margin:0px; box-shadow:none;}/*saut de page, sauf pour le dernier de la liste*/
	.vCalendarBlock:last-child	{page-break-after:avoid;}
	.vCalendarHeader			{padding-bottom:15px; font-size:14px;}/*titre de l'agendaplus petit */
	.vCalEvtLabel				{color:#333;}
}
</style>


<div class="pageFull">
	<div class="pageModMenuContainer">
		<div id="pageModMenu" class="sBlock">
			<?php
			////	PROPOSITIONS D'EVENEMENT?
			if(!empty($menuProposedEvents))  {echo $menuProposedEvents."<hr>";}

			////	AGENDAS VISIBLES
			if(!empty($visibleCalendars))
			{
				//Admin général : affiche tous les agendas
				if(Ctrl::$curUser->isAdminGeneral() && empty($displayAllCals))  {echo "<a id='adminDisplayAllCals' onclick=\"redir('?ctrl=calendar&displayAllCals=1')\" title=\"".Txt::trad("CALENDAR_displayAllCals")."\"><img src='app/img/plusSmall.png'></a>";}
				//Agendas visibles
				echo "<form action='index.php' method='get' class='vVisibleCals'>";
						foreach($visibleCalendars as $tmpCal){
							echo "<div>
									<input type='checkbox' name='displayedCalendars[]' value='".$tmpCal->_id."' id=\"displayedCal".$tmpCal->_targetObjId."\" onchange=\"$('form.vVisibleCals').submit();\" ".(CtrlCalendar::isDisplayedCal($displayedCalendars,$tmpCal)?"checked":null).">
									<label for=\"displayedCal".$tmpCal->_targetObjId."\" title=\"".$tmpCal->description."\">".$tmpCal->title."</label> ".(Tool::isMobile()==false?$tmpCal->contextMenu(["inlineLauncher"=>true]):null)."
								 </div>";
						}
				echo Txt::formValidate("valider",true)."</form><hr>";
			}
			
			////	CATEGORIES D'EVT (FILTRE)
			//Init les options
			$categoriesOptions="<a href='?ctrl=calendar' ".(Req::isParam("_idCatFilter")?null:"class='sLinkSelect'")."><div id='categoryColorAll' class='categoryColor'>&nbsp;</div> ".Txt::trad("anyCategory")."</a>";
			foreach(MdlCalendarEventCategory::getCategories() as $tmpCategory)  {$categoriesOptions.="<a href=\"?ctrl=calendar&_idCatFilter=".$tmpCategory->_id."\" ".(Req::getParam("_idCatFilter")==$tmpCategory->_id?'class="sLinkSelect"':null)." title=\"".$tmpCategory->description."\">".$tmpCategory->display()."</a>";}
			$categoriesOptions.=MdlCalendarEventCategory::addRight()  ?  "<hr><a onclick=\"lightboxOpen('?ctrl=calendar&action=CalendarEventCategoryEdit');\" id='categoryEdit'><img src='app/img/edit.png'> ".Txt::trad("CALENDAR_editCategories")."</a>"  :  null;
			$labelCategorie=Req::isParam("_idCatFilter")  ?  "<span class='sLinkSelect'>".Ctrl::getObj("calendarEventCategory",Req::getParam("_idCatFilter"))->display()."</span>"  :  Txt::trad("anyCategory");
			//Affiche le menu
			echo "<div class='menuLine sLink'>
					<div class='menuIcon'><img src='app/img/category.png'></div>
					<div>
						<div id='vMenuCategory' class='contextMenu'>".$categoriesOptions."</div>
						<span class='menuLaunch' for='vMenuCategory'>".$labelCategorie."</span>
					</div>
				</div>";
			?>

			<!--AJOUTER AGENDA PARTAGE-->
			<?php if(MdlCalendar::addRight()){ ?>
			<div class="menuLine sLink" onclick="lightboxOpen('<?= MdlCalendar::getUrlNew() ?>');" title="<?= Txt::trad("CALENDAR_ajouter_agenda_ressource_bis") ?>">
				<div class="menuIcon"><img src="app/img/calendar/calendarAdd.png"></div>
				<div><?= Txt::trad("CALENDAR_ajouter_agenda_ressource") ?></div>
			</div>
			<?php } ?>
			
			<!--EVT PROPRIO-->
			<?php if(Ctrl::$curUser->isUser()){ ?>
			<div class="menuLine sLink" onclick="lightboxOpen('?ctrl=calendar&action=MyEvents')">
				<div class="menuIcon"><img src="app/img/calendar/myEvents.png"></div>
				<div><?= Txt::trad("CALENDAR_evt_proprio") ?></div>
			</div>
			<?php } ?>
			
			<!--IMPRIMER LA PAGE-->
			<div class="menuLine sLink" onclick="print();" title="<?= Txt::trad("CALENDAR_imprimer_agendas_infos") ?>">
				<div class="menuIcon"><img src="app/img/print.png"></div>
				<div><?= Txt::trad("CALENDAR_imprimer_agendas") ?></div>
			</div>

			<!--CALENDRIER MOIS?-->
			<?php if($displayMode!="month")  {echo "<hr><div id='datepickerCalendar'></div>";} ?>
		</div>
	</div>

	<div class="pageFullContent">
		<!--SYNTHESE DES AGENDAS ?-->
		<?php if(!empty($periodDaysSynthese)){ ?>
			<div class="vSynthese sBlock objMain">
				<div id="syntheseTable">
					<!--HEADER DE LA SYNTHESE-->
					<div id="syntheseLineHeader">
						<div class="vSyntheseLabel">&nbsp;</div>
						<?php foreach($periodDaysSynthese as $tmpDay)  {echo "<div class=\"vSyntheseDay ".(date("Y-m-d",$tmpDay["timeBegin"])==date("Y-m-d")?"vSyntheseDayCurDay":null)."\">".(int)date("d",$tmpDay["timeBegin"])."</div>";} ?>
					</div>
					<!--AFFICHE CHAQUE AGENDA-->
					<?php foreach($displayedCalendars as $tmpCal){ ?>
					<div class="vSyntheseLine">
						<div class="vSyntheseLabel sLink" onclick="toScroll('#blockCal<?= $tmpCal->_targetObjId ?>')"><?= $tmpCal->title ?></div>
						<!--CELLULES DE CHAQUE JOUR DE L'AGENDA-->
						<?php
						foreach($periodDaysSynthese as $tmpDay)
						{
							//Tooltip des evts du jour
							$tmpEvtTooltip="<div class='vSyntheseDayEvtTooltip'>".$tmpCal->title." : ".Txt::displayDate($tmpDay["timeBegin"],"dateFull")."<ul>";
							foreach($tmpDay["calsEvts"][$tmpCal->_id] as $tmpEvt)	{$tmpEvtTooltip.="<li>".Txt::displayDate($tmpEvt->dateBegin,"mini",$tmpEvt->dateEnd)." : ".Txt::reduce($tmpEvt->title,60)."</li>";}
							$tmpEvtTooltip.="</ul></div>";
							//Cellule des evts du jour
							$syntheseDayCalWE=$syntheseDayEvts=null;
							if(date("N",$tmpDay["timeBegin"])>5)	{$syntheseDayCalWE="vSyntheseDayCalWE";}
							foreach($tmpDay["calsEvts"][$tmpCal->_id] as $tmpEvt)	{$syntheseDayEvts.="<div class='vSyntheseDayEvt sLink' onclick=\"lightboxOpen('".$tmpEvt->getUrl("vue")."')\" style=\"background-color:".$tmpEvt->catColor."\">&nbsp;</div>";}
							echo "<div class='vSyntheseDay vSyntheseDayCal ".$syntheseDayCalWE."'>
									<div class='vSyntheseDayEvts' title=\"".$tmpEvtTooltip."\">".$syntheseDayEvts."</div>
								  </div>";
						}
						?>
					</div>
					<?php } ?>
					<!--LIGNE DE SYNTHESE DES AGENDAS-->
					<div class="vSyntheseLineFooter">
						<div class="vSyntheseLabel"><?= Txt::trad("CALENDAR_synthese") ?></div>
						<?php foreach($periodDaysSynthese as $tmpDay){ ?>
						<div class="vSyntheseDay vSyntheseDayCal <?= date("N",$tmpDay["timeBegin"])>5?"vSyntheseDayCalWE":null ?>">
							<div class="vSyntheseDayEvts">
								<?php if(!empty($tmpDay["nbCalsOccuppied"])){ ?><div class="vSyntheseDayEvt" style="background-color:#777" title="<div class='vSyntheseDayEvtTooltip'><?= "".$tmpDay["nbCalsOccuppied"]."</div>" ?>">&nbsp;</div><?php } ?>	
							</div>
						</div>
						<?php } ?>
					</div>
				</div>
			</div>
		<?php } ?>

		<!--AFFICHE CHAQUE AGENDA-->
		<?php foreach($displayedCalendars as $tmpCal){ ?>
		<div class="vCalendarBlock sBlock objMain" id="blockCal<?= $tmpCal->_targetObjId ?>">
			<!--HEADER DU CALENDRIER-->
			<div class="vCalendarHeader" id="headerCal<?= $tmpCal->_targetObjId ?>">
				<div class="vCalendarTitle" title="<?= $tmpCal->description ?>"><?= $tmpCal->contextMenu(["inlineLauncher"=>true]); ?><?= $tmpCal->title ?>&nbsp;<?= $tmpCal->type=="user" ? Ctrl::getObj("user",$tmpCal->_idUser)->getImg() : null ?></div>
				<div class="vCalendarPeriod">
					<img src="app/img/navPrevious.png" class="vCalendarPrevNext sLink noPrint" onclick="redir('?ctrl=calendar&curTime=<?= $timePrev ?>')" title="<?= Txt::trad("CALENDAR_periode_precedante") ?>">
					<span for="calMonthPeriodMenu" class="menuLaunch"><?= $labelPeriod ?></span>
					<?php if(!empty($calMonthPeriodMenu))  {echo "<div class='contextMenu' id='calMonthPeriodMenu'><div id='calMonthPeriodMenu2'>".$calMonthPeriodMenu."</div></div>";} ?>
					<img src="app/img/navNext.png" class="vCalendarPrevNext sLink noPrint" onclick="redir('?ctrl=calendar&curTime=<?= $timeNext ?>')" title="<?= Txt::trad("CALENDAR_periode_suivante") ?>">
				</div>
				<div class="vCalendarDisplayMode">
					<span for="menuDisplayMode" class="menuLaunch"><img src="app/img/calendar/display<?= ucfirst($displayMode) ?>.gif"> <img src="app/img/arrowBottom.png"></span>
					<div class="contextMenu" id="menuDisplayMode">
						<?php
						//Affiche chaque mode d'affichage
						foreach(["month","week","workWeek","day"] as $displayModeTmp)
							{echo "<div class='menuLine ".($displayModeTmp==$displayMode?"sLinkSelect":"sLink")."' onclick=\"redir('?ctrl=calendar&displayMode=".$displayModeTmp."')\"><div class='menuIcon'><img src='app/img/calendar/display".ucfirst($displayModeTmp).".gif'></div><div>".Txt::trad("CALENDAR_display".ucfirst($displayModeTmp))."</div></div>";}
						?>
						<hr>
						<div class="menuLine sLink" onclick="redir('?ctrl=calendar&curTime=<?= time() ?>')"><div class="menuIcon"><img src="app/img/calendar/displayToday.gif"></div><div><?= Txt::trad("aff_aujourdhui") ?></div></div>
					</div>
				</div>
			</div>
			<!--CONTENU DU CALENDRIER ("VueCalendarMonth"/"VueCalendarWeek")-->
			<div class="vCalendarVue" data-targetObjId="<?= $tmpCal->_targetObjId ?>"><?= $tmpCal->calendarVue ?></div>
		</div>
		<?php } ?>
		<!--AUCUN AGENDA-->
		<?php if(empty($displayedCalendars)){ ?><div class="pageEmptyContent"><?= Txt::trad("CALENDAR_aucun_agenda_visible") ?></div><?php } ?>
	</div>
</div>