CREATE TABLE `ap_agora` (
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `lang` varchar(255) DEFAULT NULL,
  `timezone` varchar(255) DEFAULT NULL,
  `wallpaper` varchar(255) DEFAULT NULL,
  `logo` varchar(255) DEFAULT NULL,
  `logoUrl` varchar(255) DEFAULT NULL,
  `dateUpdateDb` datetime NOT NULL,
  `version_agora` varchar(255) DEFAULT NULL,
  `skin` varchar(255) DEFAULT NULL,
  `footerHtml` text,
  `messengerDisabled` tinyint(4) unsigned DEFAULT NULL,
  `personalCalendarsDisabled` tinyint(4) unsigned DEFAULT NULL,
  `moduleLabelDisplay` varchar(255) DEFAULT NULL,
  `personsSort` varchar(255) DEFAULT NULL,
  `logsTimeOut` smallint(6) DEFAULT NULL,
  `ldap_server` varchar(255) DEFAULT NULL,
  `ldap_server_port` varchar(255) DEFAULT NULL,
  `ldap_admin_login` varchar(255) DEFAULT NULL,
  `ldap_admin_pass` varchar(255) DEFAULT NULL,
  `ldap_base_dn` varchar(255) DEFAULT NULL,
  `ldap_crea_auto_users` tinyint(4) unsigned DEFAULT NULL,
  `ldap_pass_cryptage` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_calendar` (
`_id` mediumint(8) unsigned NOT NULL,
  `type` varchar(255) DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `timeSlot` varchar(255) DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_calendarEvent` (
`_id` mediumint(8) unsigned NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `dateBegin` datetime DEFAULT NULL,
  `dateEnd` datetime DEFAULT NULL,
  `_idCat` smallint(5) unsigned DEFAULT NULL,
  `important` tinyint(4) unsigned DEFAULT NULL,
  `contentVisible` varchar(255) DEFAULT NULL,
  `periodType` varchar(255) DEFAULT NULL,
  `periodValues` varchar(1000) DEFAULT NULL,
  `periodDateEnd` date DEFAULT NULL,
  `periodDateExceptions` text,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_calendarEventAffectation` (
  `_idEvt` mediumint(8) unsigned NOT NULL,
  `_idCal` mediumint(8) unsigned NOT NULL,
  `confirmed` tinyint(3) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_calendarEventCategory` (
`_id` smallint(5) unsigned NOT NULL,
  `_idSpaces` text,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `color` varchar(255) DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_contact` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idContainer` mediumint(8) unsigned NOT NULL,
  `civility` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `picture` varchar(255) DEFAULT NULL,
  `companyOrganization` text,
  `function` text,
  `adress` text,
  `postalCode` varchar(255) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `country` varchar(255) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `telmobile` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `mail` text,
  `website` text,
  `skills` text,
  `hobbies` text,
  `comment` text,
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_contactFolder` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idContainer` mediumint(8) unsigned NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_dashboardNews` (
`_id` mediumint(8) unsigned NOT NULL,
  `description` text,
  `une` tinyint(4) unsigned DEFAULT NULL,
  `offline` tinyint(4) unsigned DEFAULT NULL,
  `dateOnline` datetime DEFAULT NULL,
  `dateOffline` datetime DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_file` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idContainer` mediumint(8) unsigned NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `octetSize` int(11) DEFAULT NULL,
  `downloadsNb` int(10) unsigned NOT NULL DEFAULT '0',
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_fileFolder` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idContainer` mediumint(8) unsigned NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_fileVersion` (
  `_idFile` mediumint(8) unsigned DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `realName` text,
  `octetSize` int(10) unsigned DEFAULT NULL,
  `description` text,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_forumMessage` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idMessageParent` int(10) unsigned DEFAULT NULL,
  `_idContainer` mediumint(8) unsigned DEFAULT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_forumSubject` (
`_id` mediumint(8) unsigned NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `_idTheme` smallint(6) DEFAULT NULL,
  `dateLastMessage` datetime DEFAULT NULL,
  `usersConsultLastMessage` varchar(1000) DEFAULT NULL,
  `usersNotifyLastMessage` varchar(1000) DEFAULT NULL,
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_forumTheme` (
`_id` smallint(5) unsigned NOT NULL,
  `_idSpaces` text,
  `title` varchar(255) DEFAULT NULL,
  `description` text,
  `color` varchar(255) DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_invitation` (
  `_idInvitation` varchar(255) DEFAULT NULL,
  `_idSpace` smallint(6) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `mail` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_joinSpaceModule` (
  `_idSpace` smallint(5) unsigned DEFAULT NULL,
  `moduleName` varchar(255) DEFAULT NULL,
  `rank` tinyint(4) unsigned DEFAULT NULL,
  `options` text
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_joinSpaceUser` (
  `_idSpace` smallint(5) unsigned DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `allUsers` tinyint(3) unsigned DEFAULT NULL,
  `accessRight` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_link` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idContainer` mediumint(8) unsigned NOT NULL,
  `adress` text,
  `description` text,
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_linkFolder` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idContainer` mediumint(8) unsigned NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_log` (
  `action` varchar(50) DEFAULT NULL,
  `moduleName` varchar(50) DEFAULT NULL,
  `objectType` varchar(50) DEFAULT NULL,
  `_idObject` mediumint(8) unsigned DEFAULT NULL,
  `date` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `_idSpace` smallint(5) unsigned DEFAULT NULL,
  `ip` varchar(100) DEFAULT NULL,
  `comment` varchar(300) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_mailHistory` (
`_id` mediumint(8) unsigned NOT NULL,
  `recipients` text,
  `title` text,
  `description` text,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_objectAttachedFile` (
`_id` mediumint(8) unsigned NOT NULL,
  `name` text,
  `objectType` varchar(255) DEFAULT NULL,
  `_idObject` mediumint(8) unsigned DEFAULT NULL,
  `downloadsNb` int(10) unsigned NOT NULL DEFAULT '0'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_objectTarget` (
  `objectType` varchar(255) DEFAULT NULL,
  `_idObject` mediumint(8) unsigned DEFAULT NULL,
  `_idSpace` smallint(5) unsigned DEFAULT NULL,
  `target` varchar(255) DEFAULT NULL,
  `accessRight` float unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_space` (
`_id` smallint(5) unsigned NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `public` tinyint(4) unsigned DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `usersInscription` tinyint(4) unsigned DEFAULT NULL,
  `usersInvitation` tinyint(4) unsigned DEFAULT NULL,
  `wallpaper` varchar(255) DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_task` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idContainer` mediumint(8) unsigned NOT NULL,
  `title` text,
  `description` text,
  `priority` varchar(255) DEFAULT NULL,
  `advancement` tinyint(4) unsigned DEFAULT NULL,
  `humanDayCharge` float DEFAULT NULL,
  `budgetAvailable` int(10) unsigned DEFAULT NULL,
  `budgetEngaged` int(10) unsigned DEFAULT NULL,
  `responsiblePersons` text,
  `dateBegin` datetime DEFAULT NULL,
  `dateEnd` datetime DEFAULT NULL,
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_taskFolder` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idContainer` mediumint(8) unsigned NOT NULL,
  `name` varchar(255) DEFAULT NULL,
  `description` text,
  `shortcut` tinyint(4) unsigned DEFAULT NULL,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `guest` varchar(255) DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_user` (
`_id` mediumint(8) unsigned NOT NULL,
  `civility` varchar(255) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `login` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `picture` varchar(255) DEFAULT NULL,
  `adress` text,
  `postalCode` varchar(255) DEFAULT NULL,
  `city` varchar(255) DEFAULT NULL,
  `country` varchar(255) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `telmobile` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `mail` text,
  `website` text,
  `skills` text,
  `hobbies` text,
  `function` text,
  `companyOrganization` text,
  `comment` text,
  `lastConnection` int(10) unsigned DEFAULT NULL,
  `previousConnection` int(10) unsigned DEFAULT NULL,
  `generalAdmin` tinyint(4) unsigned DEFAULT NULL,
  `lang` varchar(255) DEFAULT NULL,
  `connectionSpace` varchar(255) DEFAULT NULL,
  `calendarDisabled` tinyint(4) unsigned DEFAULT NULL,
  `_idNewPassword` varchar(255) DEFAULT NULL,
  `ipControlAdresses` text,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_userGroup` (
`_id` smallint(5) unsigned NOT NULL,
  `title` varchar(255) DEFAULT NULL,
  `_idSpace` mediumint(8) unsigned DEFAULT NULL,
  `_idUsers` text,
  `dateCrea` datetime DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `dateModif` datetime DEFAULT NULL,
  `_idUserModif` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_userInscription` (
`_id` mediumint(8) unsigned NOT NULL,
  `_idSpace` smallint(5) unsigned DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL,
  `firstName` varchar(255) DEFAULT NULL,
  `mail` varchar(255) DEFAULT NULL,
  `login` varchar(255) DEFAULT NULL,
  `password` varchar(255) DEFAULT NULL,
  `message` text,
  `date` datetime DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_userLivecouter` (
  `_idUser` mediumint(8) unsigned NOT NULL DEFAULT '0',
  `ipAdress` varchar(255) DEFAULT NULL,
  `editObjId` tinytext,
  `date` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_userMessenger` (
  `_idUserMessenger` mediumint(8) unsigned DEFAULT NULL,
  `allUsers` tinyint(3) unsigned DEFAULT NULL,
  `_idUser` mediumint(8) unsigned DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_userMessengerMessage` (
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `_idUsers` text,
  `message` text,
  `color` varchar(255) DEFAULT NULL,
  `date` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

CREATE TABLE `ap_userPreference` (
  `_idUser` mediumint(8) unsigned DEFAULT NULL,
  `keyVal` varchar(255) DEFAULT NULL,
  `value` varchar(255) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=utf8;




ALTER TABLE `ap_calendar`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idUser`);

ALTER TABLE `ap_calendarEvent`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idCat`,`_idUser`);

ALTER TABLE `ap_calendarEventAffectation`
 ADD PRIMARY KEY (`_idEvt`,`_idCal`), ADD KEY `indexes` (`_idEvt`,`_idCal`);

ALTER TABLE `ap_calendarEventCategory`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idUser`);

ALTER TABLE `ap_contact`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_contactFolder`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_dashboardNews`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idUser`);

ALTER TABLE `ap_file`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_fileFolder`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_fileVersion`
 ADD KEY `indexes` (`_idFile`,`_idUser`);

ALTER TABLE `ap_forumMessage`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idMessageParent`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_forumSubject`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idTheme`,`_idUser`);

ALTER TABLE `ap_forumTheme`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idUser`);

ALTER TABLE `ap_invitation`
 ADD KEY `indexes` (`_idInvitation`,`_idSpace`,`_idUser`);

ALTER TABLE `ap_joinSpaceModule`
 ADD KEY `indexes` (`_idSpace`);

ALTER TABLE `ap_joinSpaceUser`
 ADD KEY `indexes` (`_idSpace`,`_idUser`);

ALTER TABLE `ap_link`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_linkFolder`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_log`
 ADD KEY `indexes` (`_idObject`,`_idUser`,`_idSpace`);

ALTER TABLE `ap_mailHistory`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idUser`);

ALTER TABLE `ap_objectAttachedFile`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idObject`);

ALTER TABLE `ap_objectTarget`
 ADD KEY `indexes` (`_idObject`,`_idSpace`);

ALTER TABLE `ap_space`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`);

ALTER TABLE `ap_task`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_taskFolder`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idContainer`,`_idUser`);

ALTER TABLE `ap_user`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idNewPassword`);

ALTER TABLE `ap_userGroup`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idSpace`,`_idUsers`(255),`_idUser`);

ALTER TABLE `ap_userInscription`
 ADD PRIMARY KEY (`_id`), ADD KEY `indexes` (`_id`,`_idSpace`);

ALTER TABLE `ap_userLivecouter`
 ADD PRIMARY KEY (`_idUser`), ADD KEY `indexes` (`_idUser`);

ALTER TABLE `ap_userMessenger`
 ADD KEY `indexes` (`_idUserMessenger`,`_idUser`);

ALTER TABLE `ap_userMessengerMessage`
 ADD KEY `indexes` (`_idUser`);

ALTER TABLE `ap_userPreference`
 ADD KEY `indexes` (`_idUser`);




ALTER TABLE `ap_calendar`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_calendarEvent`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_calendarEventCategory`
MODIFY `_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_contact`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_contactFolder`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_dashboardNews`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_file`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_fileFolder`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_forumMessage`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_forumSubject`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_forumTheme`
MODIFY `_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_link`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_linkFolder`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_mailHistory`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_objectAttachedFile`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_space`
MODIFY `_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_task`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_taskFolder`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_user`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_userGroup`
MODIFY `_id` smallint(5) unsigned NOT NULL AUTO_INCREMENT;
ALTER TABLE `ap_userInscription`
MODIFY `_id` mediumint(8) unsigned NOT NULL AUTO_INCREMENT;




INSERT INTO ap_agora SET name='Agora-Project', personsSort='firstName', logsTimeOut='30', version_agora='3.0.0', dateUpdateDb=NOW();

INSERT INTO ap_space SET _id=1, usersInvitation=1;

INSERT INTO ap_joinSpaceModule (_idSpace,moduleName,rank) VALUES 
(1, 'dashboard', 1),
(1, 'file', 2),
(1, 'calendar', 3),
(1, 'forum', 4),
(1, 'contact', 5),
(1, 'link', 6),
(1, 'task', 7),
(1, 'user', 8),
(1, 'mail', 9);

INSERT INTO ap_joinSpaceUser SET _idSpace=1, allUsers=1, accessRight=1;

INSERT INTO ap_user SET _id=1, generalAdmin=1;

INSERT INTO ap_userMessenger SET _idUserMessenger=1, allUsers=1;

INSERT INTO ap_contactFolder SET _id=1, _idContainer=0;

INSERT INTO ap_fileFolder SET _id=1, _idContainer=0;

INSERT INTO ap_linkFolder SET _id=1, _idContainer=0;

INSERT INTO ap_taskFolder SET _id=1, _idContainer=0;

INSERT INTO ap_objectTarget (objectType,_idObject,_idSpace,target,accessRight) VALUES 
('dashboardNews', 1, 1, 'spaceUsers', 1),
('calendar', 1, 1, 'spaceUsers', 1.5),
('fileFolder', 1, 1, 'spaceUsers', 2),
('contactFolder', 1, 1, 'spaceUsers', 2),
('taskFolder', 1, 1, 'spaceUsers', 2),
('linkFolder', 1, 1, 'spaceUsers', 2);

INSERT INTO ap_dashboardNews SET _id=1, _idUser=1;

INSERT INTO ap_calendar (_id,type,_idUser,title) VALUES 
(1, 'ressource', 1, NULL),
(2, 'user', 1, NULL);

INSERT INTO ap_calendarEventCategory (_id,color,title) VALUES 
(1, '#770000', 'rendez-vous'),
(2, '#000077', 'réunion'),
(3, '#dd7700', 'congés'),
(4, '#007700', 'personnel');